from intersectionLib import *
from drawTSP import *
from setCity4 import *
#------------(近似的巡回路設定用関数)-----------------------
def lenVisit(XX):       #■訪問巡回路長計算
    N=len(XX);NN=N-1;T=0;j=NN
    for i in range(N):
        T+=compR(XX[j][0],XX[j][1],XX[i][0],XX[i][1])
        j=i
    return T
def insertList(XX,XY,ID):#■リスト挿入
    N=len(XX); R=array(N+1);ii=0
    for i in range(N):
        R[ii]=XX[i]; ii+=1
        if ID==i:R[ii]=XY; ii+=1
    return R
def selectInsertCity(XX,XY):#■挿入する辺を選択
    N=len(XX);NN=N-1;minR=1E32;mnL=[]
    for i in range(N):
        DR=lenVisit(insertList(XX,XY,i))
        if DR<minR:minR=DR;ID=i
    return ID
def inseartCity0(root, canvas,IDF,cityXY,XX,drawNoFlag):#都市挿入
    XY=cityXY[IDF]; ID=selectInsertCity(XX,XY)
    XX= insertList(XX,XY,ID);del cityXY[IDF]
    drawCityData(canvas, XX,cityXY,drawNoFlag)
    root.update()
    return XX
def inseartCity(root,canvas, XX,MM,      #■初期多角形に都市を挿入する
                setCityMethod, cityXY, drawNoFlag):
    N=len(cityXY);XY0=centerP(MM)
    if setCityMethod==1:
        while cityXY!=[]:#中心から近い頂点に最も近い点を挿入点とする
            N=len(XX); D=nearXY(XX, XY0[0],XY0[1]); i=D[0]
            D=nearXY(cityXY, XX[i][0],XX[i][0]); IDF=D[0]
            XX=inseartCity0(root,canvas,IDF,cityXY,XX,drawNoFlag)
    else:
        while cityXY!=[]:         # 中心から遠い点を挿入点とする
            D=farXY(cityXY,XY0[0],XY0[1]); IDF=D[0]
            XX=inseartCity0(root, canvas,IDF,cityXY,XX,drawNoFlag)
    return XX
